/*
 * Aufgabe2.java
 *
 * Created on 27. April 2006, 16:39
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

/**
 *
 * @author Yves Radunz
 */

import HUMath.Numerik.*;

public class Aufgabe2 {
    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        //Infozeilen
        System.out.println("Wissenschaftliches Rechnen II");
        System.out.println("Loesung: Serie 1 - Aufgabe 2");
        System.out.println("Copyright (C) 2006 Yves Radunz");
        
        //Mantissenlaenge durchlaufen lassen
        for (int mantl = 10; mantl < 21; mantl+=2) {
            System.out.println("\nMantissenlaenge = " + mantl);
            
            //Rekursions-Startwerte festlegen
            Digit faktor = (new Digit(10,mantl)).divide(new Digit(3,mantl)),
                  neu, 
                  alt = new Digit(1, mantl),
                  sehralt = new Digit(3, mantl);
            
            //Iteration durchfuehren
            for (int n = 1; n < 16; n++) {
                //Berechnen
                neu = alt.multiply(faktor).subtract(sehralt);
                
                //Fehler berechnen
                Digit vergleichswert = vgl(n), zwischenspeicher = new Digit(neu,100);
                double relfehler = (new Digit(neu, 100)                  //erst mal eine neue Zahl mit groesserer Mantisse erstellen,
                                                                         //im die Fehler in der Fehlerberechnung zu verringern
                                  ).subtract(vergleichswert              //Differenz zum Vergleichswert
                                            ).divide(vergleichswert      //relativer Fehler
                                                    ).abs(               //Betrag des relativen Fehlers ...
                                                         ).doubleValue();// ... als double-Wert speichern.
                System.out.println("n = " + str2(n) + ": rel. Fehler = " + str22(relfehler) + " f(n) = " + neu);
                
                //Werte fuer die naechste Iteration kopieren
                sehralt = alt; alt = neu;
            }            
        }
    }
    
    //Vergleichswerte
    private static Digit vgl(int nr){
        if (nr == 0) return new Digit(1,100);           //3 hoch 0 ist immer 1.
        return vgl(nr-1).divide(new Digit(3,100));
    }
    
    //String mit einer Laenge von mindestens 25 Zeichen aus einem double-Wert erzeugen
    private static String str22(double wert){
        //Wert in String umwandeln
        String tmp = String.valueOf(wert);
        //auf mindestens 22 Zeichen verlaengern
        while (tmp.length() < 22)
            tmp += " ";
        return tmp;
    }
    
    //String mit einer Laenge von mindestens 2 Zeichen aus einem integer-Wert erzeugen
    private static String str2(int wert){
        //Wert in String umwandeln
        String tmp = String.valueOf(wert);
        //auf mindestens 2 Zeichen verlaengern
        while (tmp.length() < 2)
            tmp += " ";
        return tmp;
    }
}
