/*
 * Main.java
 *
 * Created on 30. Mai 2006, 13:11
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

/**
 *
 * @author radunz
 */
public class Main {
    
    private final static double x=.00001;
    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        //Allgemeine Informationen
        System.out.println("Wissenschaftliches Rechnen II");
        System.out.println("Loesung: Serie 2 - Aufgabe 4");
        System.out.println("Copyright (C) 2006 Yves Radunz\n");
        System.out.println("1. Programm");
        System.out.println("Iterative Berechnung von cos((M+1)x)");
        System.out.println("Getestet werden: x=0.00001, M=10000(10000)(50000)");        
        System.out.println("\n1. iterative Berechnungsvorschrift");
        System.out.println("M\tcos((M+1)x)\t\tcos1((M+1)x)\t\trelativer Fehler");
        
        //Ausgabe der Ergebnisse fuer die erste Berechnungsvorschrift
        double cos_exakt, cos_iterativ;
        for (int m = 10000; m <= 50000; m += 10000){            
            cos_exakt = Math.cos((m + 1) * x);
            cos_iterativ = cos1it(x, m);
            System.out.println(m + "\t" + cos_exakt + "\t" + cos_iterativ + "\t"  //Ausgabe der Ergebnisse
                    + Math.abs(cos_iterativ - cos_exakt) / cos_exakt);           //relativer Fehler
        }
        
        //Ausgabe fuer die 2. Berechnungsvorschrift
        System.out.println("\n2. iterative Berechnungsvorschrift");
        System.out.println("M\tcos((M+1)x)\t\tcos2((M+1)x)\t\trelativer Fehler");
        for (int m = 10000; m <= 50000; m += 10000){            
            cos_exakt=Math.cos((m + 1) * x);
            cos_iterativ=cos2it(x, m);
            System.out.println(m + "\t" + cos_exakt + "\t" + cos_iterativ + "\t" + Math.abs(cos_iterativ - cos_exakt) / cos_exakt);
        }
    }
    
    private static double cos1it(double x, int m){
        //Definition der erste Berechungsvorschrift (iterativ)
        
        //Speicher fuer Zwischenergebnisse
        double cos_1x       = Math.cos(x), 
               cos_mx       = Math.cos(x),
               cos_mminus1x = Math.cos(0),
               cos_neu;
        
        m++;  //Berechnung von cos((m+1)x), nicht von cos(mx)
        
        //Iteration
        for (int i = 2; i <= m; i++){
            //neuen Wert berechnen
            cos_neu = 2 * cos_1x * cos_mx - cos_mminus1x;
            
            //Werte kopieren
            cos_mminus1x = cos_mx;
            cos_mx = cos_neu;
        }
        
        return cos_mx;
    }
    
    private static double cos2it(double x, int m){        
        //2. Berechnungsvorschrift (iterativ)
        
        //Speicher fuer Zwischenergebnisse
        double cos_1x=Math.cos(x), sin_1x=Math.sin(x),
               cos_mx=Math.cos(x), sin_mx=Math.sin(x),
               cos_neu, sin_neu;
        
        m++;
        
        //Berechnung
        for (int i=2;i<=m;i++){
            //neue Zwischenergebnisse berechnen
            cos_neu=cos_1x*cos_mx-sin_1x*sin_mx;
            sin_neu=cos_1x*sin_mx+sin_1x*cos_mx;
            
            //kopieren
            cos_mx=cos_neu;
            sin_mx=sin_neu;
        }
            
        return cos_mx;
    }
}
